public enum OperatingSystem
{
    WINDOWS,
    MACOSX,
    MAX_SUPPORTED_OS;
    
    private static String m_appDataPathCache = null;
    private static OperatingSystem m_osCache = null;
    
    private static boolean m_isWindowsXP = false;
    
    public static OperatingSystem GetCurrentOS()
    {
        if( m_osCache != null )
            return m_osCache;
            
        String osName = System.getProperty("os.name");
        if( osName.toLowerCase().contains("windows xp") )
        {
            m_isWindowsXP = true;
        }
        
        if( osName.toLowerCase().contains("windows") )
            m_osCache = WINDOWS;
        else if( osName.toLowerCase().contains("mac os x") )
            m_osCache = MACOSX;
        
        if( m_osCache != null )
            return m_osCache;
            
        System.out.println("Unrecognized operating system!");
        System.exit(-1);
        return WINDOWS;
    }
    
    public static String GetApplicationDataDirectory()
    {
        if( m_appDataPathCache != null )
            return m_appDataPathCache;
            
        if( GetCurrentOS() == WINDOWS)
        {
            // leave it to fucking windows...
            if( !m_isWindowsXP )
                m_appDataPathCache = System.getenv("localappdata");
            else
                m_appDataPathCache = "C:\\Documents and Settings\\" + System.getProperty("user.name") + "\\Local Settings\\Application Data";
            return m_appDataPathCache;
        }
        else if( GetCurrentOS() == MACOSX )
        {
            m_appDataPathCache = System.getProperty("user.home") + "/Library/";
            return m_appDataPathCache;
        }
        
        return "~/";
    }
    
    public static String GetDataDirectoryForOS()
    {
        if( GetCurrentOS() == WINDOWS )
        {
            return GetApplicationDataDirectory() + "\\MapCraft\\";
        } else if( GetCurrentOS() == MACOSX )
        {
            return GetApplicationDataDirectory() + "/MapCraft/";
        }
        
        return "";
    }
    
    public static boolean is64BitArchitecture()
    {
        return (System.getProperty("os.arch").indexOf("64") != -1 );
    }
    
}
